;***************************************************************************
;* A P P L I C A T I O N   N O T E   F O R   T H E   A V R   F A M I L Y
;* 
;* Number		: AVR test
;* File Name            :"T25time.asm"
;* Title                :Tiny25 timer
;* Date                 :24.12.2008
;* Version              :1.0
;* Support forum        :www.skif.biz/index.php?name=Forums&file=viewtopic&t=3078&pagenum=1
;* Support fax          :     ,   -
;* Target MCU           :tiny25
;*
;* DESCRIPTION
;*    0 AtTiny25/45/85  
;*   
;*
;* The timing is adapted for 8Mhz internal clok
;* 
;*Fuses 
;*  ,       
;*    -  ,     . 
;*   SPIEN   ,     
;*  -.
;*
;*  OSCCAL        = 90
; 
; 
;*  CKDIV         = 1   8MHZ     =0  1MHZ
;      
;  

;*  CKOUT         = 1            =0  PB3 out
;         
; (0     , 1  ) 

;*  SUT           = 0
;     /
 
;*  CKSEL         = 2
;     ,   
;    / 

;*  RSTDISBL      = 1
;     , 
;      
; (0     /, 1   ) 

;*  DWEN          = 1
; /    
; debugWire (0  , 1  ) 

;*  WDTON         = 1 
;     
; (0  , 1     ) 
;  (Watch Dog Timer)     . 
;   :
;     ( WDTON  ATtiny2313),  ,
;       . 
;            
;    (   WDR). 
;        WDR   ,
;       . 
;      .
;   ,        .
;
;*  EESAVE        = 1            
; EEPROM- (0   , 1  ) 

;*  BODLEVEL      = 7       BOR
 
;*  SELFPRGEN     = 1    (0  , 1  ) 
;*
;*
;*
;***************************************************************************
;.device tiny25
	;  ,   . 
	;      ,
	;     -
	;  ,    
	;      .
	; "   -     "-
.include "tn25def.inc"  			; 
	; ".include"    ,
	;      .
.def      tm	=R16				;  ".def"  (   )
  									;     ( - ).
 									;  R16    tm, 
									;          

.cseg                      			;    CSEG (   :
									; 1. CSEG -  ( );
									; 2. ESEG -  EEPROM;
									; 3. DSEG -  ( ,(RAM)) 

.org 0  	rjmp	reset			;            "reset:"
									;   http://www.skif.biz/index.php?name=Forums&file=viewtopic&p=301338#301338
.org 1
.org 2
.org 3
.org 4
.org 5
.org 6
.org 7
.org 8
.org 9
.org 10
.org 11
.org 12
.org 13
.org 14
.org 15
.org 16


reset:	  cli                      	 ; all interrupt disable -  ,
;         clr       tm	  			 ;  .     -
                       	 			 ;    .     - . .
									 ;           - 
									 ;    ! -    ? ;-) JohnZ

          ldi       tm, 0x90 		 ;     144 ?(..?)
		  out       osccal, tm       ; set generator  tm  osccal
       
    	  ldi       r16, 0x17		 ;     = 0b00010111
		  out       ddrb, r16        ; set port B0,1,2,4 out,      R16


timer0:                     	    ;  "timer0:"    -  
		
		  ldi       tm, 0x0f0		; set 30mks	  tm  "0xf0" f0=240=30mks, 1  0,125		
		  out       ocr0a, tm 		;    ocr0a  tm="0xf0"(     30mks)  
		  ldi       tm, 0x28		; set 5mks,  5mks(28=40=5mks) ???   ???  .
		  out       ocr0b, tm		;    ocr0b  tm="0x28"(     5mks   )

		  ldi	    tm, 0x63		; set fast PWM  OCRb- output = 0b01100011
		  out       tccr0a, tm		; 
		  ldi       tm, 0x09		; set Fcl   Fast PWM = 0b00001001
		  out       tccr0b, tm		;  

	      sei						;  (  "cli"    )					
		  ldi       tm, 0x20	    ; set sleep enable = 0b00100000
		  out       mcucr, tm		;   
		  sleep 					;  
timer1: 
		cli
		ldi	R17, 0x0b0				; = 0b10110000
		ldi	R16, 0x0b4				; BOD Sleep, Sleep,  Power-down, BOD Sleep Enable = 0b10110100
		out	MCUCR, R16
		out	MCUCR, R17				; BOD Sleep, Sleep,  Power-down
		sei
		sleep
